#! /usr/bin/python

import cgi
import sys, os, time

#################################################################
# Path to data directory.
# You must change this to your own location. 
#
# This is the absolute system path (e.g. starting with
# /home/user or /var/www), not the relative path in your website.

datadir = "/path/to/geocenter/data"

# Delete old people.xml files, or leave them there?
# Leaving them in place gives you a way to recover if the
# program fails, or if spammers come in and make lots of
# bogus entries and you want to revert to a date/time.
clean_up_files = True

# You shouldn't have to change anything else in this file.
#################################################################

form = cgi.FieldStorage()
if "name" not in form or "lat" not in form or "lon" not in form:
    #print "<H1>Error</H1>"
    #print "Please fill in the name and addr fields."
    sys.exit(1)

print "Content-Type: text/html"
print
print "<head>"
#print '<meta http-equiv="refresh" content="4;URL=about:blank">'
print '</head>'
print '<body>'

peoplefilename = os.path.join(datadir, "people.xml")
peoplefile = open(peoplefilename, "r")
outfilename = os.path.join(datadir, "newpeople.xml")
outfile = open(outfilename, "w")
while True:
    line = peoplefile.readline()
    if not line : break
    if line[0:9] == "</people>" :
        break
    outfile.write(line)

#
# We've read and copied the whole file, at least up until </people>.
# Now add the new person.
#
names = form["name"].value.split(',')
lons = form["lon"].value.split(',')
lats = form["lat"].value.split(',')
print "names:", names, "<br>"
print  "lons:", lons, "<br>"
print  "lats:", lats, "<br>"
numusers = len(names)
if numusers != len(lons) or numusers != len(lats) :
    print "Error:", numusers, "users", len(lons), "longitudes", \
        len(lats), "latitudes"
    sys.exit(1)
print numusers, "users"

for i in range(0,numusers) :
    outfile.write("  <person>\n")
    outfile.write("    <name>" + names[i] + "</name>\n");
    outfile.write("    <lon>" + lons[i] + "</lon>\n");
    outfile.write("    <lat>" + lats[i] + "</lat>\n");
    outfile.write("  </person>\n")
    peoplefile.close()
outfile.write("</people>\n")
outfile.close()

if clean_up_files :
    os.unlink(peoplefilename)
else :
    os.rename(peoplefilename,
              os.path.join(datadir, "people" + str(int(time.time())) + ".xml"))
os.rename(outfilename, peoplefilename)

# Print a status that can be easily checked.
# If we bomb out early, we won't write this part.
print '<span id="success">Added users</span>'
#print "Saved", form["name"].value
print "</body></html>"


